# Config Patch

This module provides a framework for providing patch files for config (the 
differences between active configuration and sync configuration). For a site 
that's built out from source files, this allows sitebuilders to make changes to 
configuration in the UI and push a button to create a patch which may then be 
committed back to source. The framework is extensible, so additional output 
plugins may provide integrations with e.g., cloud source control providers.

Since patches reference file paths, the path of these files is configurable. In 
other words, if your synchronized config is stored in `drupal/config` in your 
source repo, you can configure `drupal/config` as your base config path in 
config_patch.

When installed, config_patch provides an additional tab `Patch` on the admin 
config synchronization pages listing config that is out of sync and providing a 
button to output the patch in various forms. It also adds a button to the admin 
toolbar that shows the number of configuration items that are out of sync.

**Available output plugins:**

- Text: provides text output of a unified diff patch
- [Gitlab](https://drupal.org/project/config_patch_gitlab): provides submission 
to Gitlab repositories using MR-by-email functionality.

**Similar modules:**

- [Config Partial Export](https://www.drupal.org/project/config_partial_export): 
export a tarball of config ymls that differ between sync and active

For a full description of the module, visit the
[project page](https://www.drupal.org/project/config_patch).

Submit bug reports and feature suggestions, or track changes in the
[issue queue](https://www.drupal.org/project/issues/config_patch).


## Table of contents

- Requirements
- Installation
- Configuration
- Maintainers


## Requirements

This module requires no modules outside of Drupal core.


## Installation

Install as you would normally install a contributed Drupal module. For further
information, see
[Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).


## Configuration

1. Configure this module at `/admin/config/development/config_patch`


## Maintainers

- Andy Hebrank - [ahebrank](https://www.drupal.org/u/ahebrank)
